%
%  Closed and Almost unstable loop
% 
%

clear; clc
N=100000;
disp('======================================================================');
disp('        Resonant Link')
%disp('         Baccala & Sameshima. Biol. Cybern. 84:463-474, 2001.')
disp('           x1 ->x2  x2->x3 (filter)                   ');
disp('======================================================================');
SEED=sum(100*clock);
randn('state', sum(100*clock))
SZ=[2 0 5;0 1 0;5 0 20];SZ=chol(SZ);
wi=randn(3,N);
wi=SZ'*wi;
x1=zeros(1,N);
x2=zeros(1,N);
x3=zeros(1,N);
x4=zeros(1,N);
%x5=zeros(1,N);
% Variables initialization
for t=1:2,
   x1(t)=randn(1); x2(t)=randn(1); x3(t)=randn(1);
   %x4(t)=randn(1);
   %x5(t)=randn(1);
end;

chLabels = []; % or 
%chLabels = {'x_1';'x_2';'x_3';'x_4';'x_5'};

for t=3:N,
   x1(t) =-.5*x1(t-1)+ wi(1,t);  
   x2(t) = 0.95*sqrt(2)*x2(t-1) - 0.9025*x2(t-2) + x1(t-1);
   x3(t) = -.5*x3(t-1) + x2(t-1)+ wi(3,t);
   x4(t) = -.5*x3(t-1) + wi(3,t); % sole x3 - actual power computation
end;

nDiscard=40000; % number of points discarded at beginning of series (sem efeito)
nPoints=1000;   % number of analyzed samples points

y=[x1' x3'];% x3'];% x4' x5']; % data must be organized column-wise

u=y(N-nPoints+1:N,:);%size(u),pause

%==========================================================================
%             original PDCn estimation and analysis parameters
%==========================================================================

run example_analysis_parameters % Setting default paramaters 

run example_pre_processing      % Detrending and/or standardization

run example_mvar_estimation     % Estimating VAR and testing adequacy of 
                                % VAR model as well as performing GCT and ICT.

%=======Overriding some default parameters for plotting and analysis=======

flgPrinting = [1 1 1 1 1 1 1]; % overriding default setting

 alpha=0.05;         % Significance level
% gct_signif = 0.05;  % Granger causality test significance level
% igct_signif = 0.05; % Instantaneous GCT significance level


if Portmanteau,
    Convergence='Good'
else
    Convergence='Bad'
end

metric = 'info';

run example_pdc_analysis

%==========================================================================
%                        PDCn Matrix Layout Plotting
%==========================================================================
w_max=fs/2;
flgPrinting = [1 1 1 2 2 1 1]; % overriding default setting
flgColor = 0;
for kflgColor = flgColor,
   h=figure;
   set(h,'NumberTitle','off','MenuBar','figure', ...
         'Name', ['Convergence=' Convergence])
   [hxlabel hylabel] = pdc_xplot_article2(c,...
                              flgPrinting,fs,w_max,chLabels,kflgColor);
   [ax,hT]=suplabel(['Order= ' int2str(IP)  ' Seed= ' num2str(SEED) ' ' ...
      int2str(nPoints) ' data points.'],'t');
   set(hT,'FontSize',10); % Title font size
   pdc_xplot_title(alpha,metric);
end;
